

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.data.prediction_manager &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.data.prediction_manager</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.data.prediction_manager</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">sqlalchemy.sql</span> <span class="k">import</span> <span class="n">func</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.database</span> <span class="k">import</span> <span class="n">dbSession</span> <span class="k">as</span> <span class="n">dB</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.models</span> <span class="k">import</span> <span class="n">Prediction</span><span class="p">,</span> <span class="n">Offer</span>


<div class="viewcode-block" id="PredictionManager"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.prediction_manager.PredictionManager">[docs]</a><span class="k">class</span> <span class="nc">PredictionManager</span><span class="p">:</span>

<div class="viewcode-block" id="PredictionManager.add_prediction"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.prediction_manager.PredictionManager.add_prediction">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">add_prediction</span><span class="p">(</span><span class="n">mark</span><span class="p">,</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">id_offer</span><span class="p">,</span> <span class="n">is_verify</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Add a prediction in database</span>

<span class="sd">        :param mark: mark of a prediction</span>
<span class="sd">        :type mark: int</span>

<span class="sd">        :param id_field: id of a field</span>
<span class="sd">        :type id_field: int</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :param is_verify: boolean if the formation is a reference for an offer</span>
<span class="sd">        :type is_verify: bool</span>

<span class="sd">        :return: boolean if the prediction was added in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">prediction</span> <span class="o">=</span> <span class="n">Prediction</span><span class="p">(</span><span class="n">mark</span><span class="p">,</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">id_offer</span><span class="p">,</span> <span class="n">is_verify</span><span class="p">)</span>
        <span class="n">dB</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">prediction</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">e</span><span class="p">)</span>
            <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="PredictionManager.delete_prediction_by_id_field"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.prediction_manager.PredictionManager.delete_prediction_by_id_field">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">delete_prediction_by_id_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Delete a prediction with an id_field</span>

<span class="sd">        :param id_field: id of a field</span>
<span class="sd">        :type id_field: int</span>

<span class="sd">        :return: Boolean if the prediction was deleted in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">Prediction</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">id_field</span><span class="o">=</span><span class="n">id_field</span><span class="p">)</span><span class="o">.</span><span class="n">delete</span><span class="p">()</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="PredictionManager.delete_prediction_by_id_offer"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.prediction_manager.PredictionManager.delete_prediction_by_id_offer">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">delete_prediction_by_id_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Delete a prediction with an id_offer</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :return: Boolean if the prediction was deleted in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">Prediction</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">id_offer</span><span class="o">=</span><span class="n">id_offer</span><span class="p">)</span><span class="o">.</span><span class="n">delete</span><span class="p">()</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="PredictionManager.fields_by_offer"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.prediction_manager.PredictionManager.fields_by_offer">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">fields_by_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Obtain id_field and mark of all prediction having this id_offer</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :return: Dictionary where each element is a list, in this list the first element is id_field and the second is a mark</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">predictions</span> <span class="o">=</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">query</span> \
            <span class="o">.</span><span class="n">with_entities</span><span class="p">(</span><span class="n">Prediction</span><span class="o">.</span><span class="n">id_field</span><span class="p">,</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">mark</span><span class="p">)</span>\
            <span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">id_offer</span><span class="o">=</span><span class="n">id_offer</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">predictions</span></div>

    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Not up to date with the new database model</span>
<span class="sd">    TODO Delete this route in routes.py (backend) and frontend.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">update_prediction_by_id_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">,</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">is_verify</span><span class="p">):</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">offer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">prediction</span> <span class="o">=</span> <span class="n">offer</span><span class="o">.</span><span class="n">prediction</span>
                <span class="k">if</span> <span class="n">id_field</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">teams</span> <span class="o">=</span> <span class="n">prediction</span><span class="o">.</span><span class="n">teams</span>
                    <span class="k">for</span> <span class="n">team</span> <span class="ow">in</span> <span class="n">teams</span><span class="p">:</span>
                        <span class="n">team</span><span class="o">.</span><span class="n">id_field</span> <span class="o">=</span> <span class="n">id_field</span>
                <span class="k">if</span> <span class="n">is_verify</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">prediction</span><span class="o">.</span><span class="n">inbase</span> <span class="o">=</span> <span class="p">(</span><span class="n">is_verify</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">True</span>
            <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">False</span>

    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Not up to date with the new database model</span>
<span class="sd">    TODO Delete this route in routes.py (backend) and frontend.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">nb_prediction</span><span class="p">(</span><span class="n">begin_date</span><span class="p">,</span> <span class="n">end_date</span><span class="p">):</span>
        <span class="n">nb_prediction</span> <span class="o">=</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">query</span> \
            <span class="o">.</span><span class="n">with_entities</span><span class="p">(</span><span class="n">func</span><span class="o">.</span><span class="n">count</span><span class="p">(</span><span class="n">Prediction</span><span class="o">.</span><span class="n">id</span><span class="p">)</span><span class="o">.</span><span class="n">label</span><span class="p">(</span><span class="s1">&#39;number&#39;</span><span class="p">))</span> \
            <span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">Prediction</span><span class="o">.</span><span class="n">date</span> <span class="o">&lt;=</span> <span class="n">end_date</span><span class="p">,</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">date</span> <span class="o">&gt;=</span> <span class="n">begin_date</span><span class="p">)</span>\
            <span class="o">.</span><span class="n">first</span><span class="p">()</span><span class="o">.</span><span class="n">number</span>
        <span class="k">return</span> <span class="n">nb_prediction</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>